<?php
require_once 'class/c_login.php';
if (!isset($_SESSION['user'])){
    die(header('Location: index.php'));
}

//$user = unserialize($_SESSION['user']);
$user = Login::get_user();

$user->access();
if ($user->acceso === null && !$user->admin){
    die(header('Location: index.php'));
    exit();
}


$periodo_rs = $db->querySingle('SELECT periodo_fecha_inicio, periodo_fecha_fin FROM periodo WHERE periodo_id = :periodo_id', [':periodo_id' => $user->periodo_id]);


if(isset($_POST["fecha_ini"]) && $_POST["fecha_ini"]!=""){
    $fecha_ini_obj = DateTime::createFromFormat('d/m/Y', $_POST["fecha_ini"]);
}else{
    $fecha_ini_obj = DateTime::createFromFormat('Y-m-d', $periodo_rs["periodo_fecha_inicio"]);
}
if(isset($_POST["fecha_fin"]) && $_POST["fecha_fin"]!=""){
    $fecha_fin_obj = DateTime::createFromFormat('d/m/Y', $_POST["fecha_fin"]);
}else{
    $fecha_fin_obj = DateTime::createFromFormat('Y-m-d', $periodo_rs["periodo_fecha_fin"]);
}

$fecha_ini = $fecha_ini_obj->format('d/m/Y');
$fecha_fin = $fecha_fin_obj->format('d/m/Y');
unset($periodo_rs);

$fs_dias_festivos = $db->query("SELECT  d.diasfestivos_id, d.diasfestivos_dia , p.periodo_id , p.periodo_nombre, extract(dow from diasfestivos_dia) AS dia_id  from diasfestivos d 
join periodo p on p.periodo_id = any (d.periodos_id) where diasfestivos_dia between :ini and :fin
order by d.diasfestivos_dia DESC", [":ini"=> $fecha_ini_obj->format('Y-m-d'), ":fin"=>$fecha_fin_obj->format('Y-m-d')]);


$dias_arr = array();
foreach ($fs_dias_festivos as $dia){
    if(isset($dias_arr[$dia["diasfestivos_id"]])){
        $dias_arr[$dia["diasfestivos_id"]]["periodos"][] = array("periodo_id"=>$dia["periodo_id"], "periodo_nombre"=>$dia["periodo_nombre"]);
    }else{
        $dias_arr[$dia["diasfestivos_id"]] = array("diasfestivos_id"=>$dia["diasfestivos_id"], "diasfestivos_dia"=>$dia["diasfestivos_dia"], "dia_id"=>$dia["dia_id"],
            "periodos"=>array(array("periodo_id"=>$dia["periodo_id"], "periodo_nombre"=>$dia["periodo_nombre"]))
        );
    }
}

$dias_nombres=array("Domingo", "Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado");
$write = true;

$fs_periodos = $db->query("SELECT periodo_id, periodo_nombre, periodo_fecha_inicio, periodo_fecha_fin FROM periodo WHERE CURRENT_DATE < periodo_fecha_fin order by id_periodo_sgu");


?>
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Días festivos</title>

    <meta charset="utf-8">
    <meta http-equiv="content-type" content="text/plain; charset=UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php
    include 'import/html_css_files.php';
    ?>
    <link rel="stylesheet" href="css/jquery-ui.css">
    <link rel="stylesheet" href="css/calendar.css">
    <link rel="stylesheet" href="css/toggle.css" type="text/css">
    <script src="js/scrollables.js" defer></script>
    <script>
        const write = <?= $write ? 'true' : 'false' ?>;
    </script>
    <script src="js/jquery.min.js"></script>
    <script src="js/bootstrap/popper.min.js"></script>
    <script src="js/bootstrap/bootstrap.min.js"></script>
    <script src="js/jquery-ui.js"></script>
    <script src="js/datepicker-es.js"></script>
    <script src="js/messages.js"></script>

</head>

<body style="display: block;">
    <?php
    include('include/constantes.php');
    include("import/html_header.php");
    html_header("Días festivos", "Sistema de gestión de checador");
    ?>
    <?= "<!-- $user -->" ?>
    <main class="container content marco content-margin" id="local-app">
        
        <section id="message"></section>
        
        <?php if($user->admin){ ?>
        <div class="col-12 text-right">
            <button type="button" class="btn btn-outline-secondary" data-toggle="modal" data-target="#modal" data-tipo="1"><span class="ing-mas ing-fw"></span> Agregar Día Festivo</button>
        </div>
        <?php } ?>
        <div id="message"></div>
        <form action="días_festivos.php" method="post" class="">
            <div class="form-box">
                <div class="form-group row">
                    <label for="filter_fecha_ini" class="col-4 col-form-label">Fecha inicial</label>
                    <div class="col-8 col-sm-4">
                        <input id="filter_fecha_ini" name="fecha_ini" type="text" class="form-control date-picker" placeholder="dd/mm/aaaa" maxlength="10" required="required" readonly="" value="<?php echo $fecha_ini;?>">
                        <div class="invalid-feedback">No es una fecha válida.</div>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="filter_fecha_fin" class="col-4 col-form-label">Fecha final</label>
                    <div class="col-8 col-sm-4">
                        <input id="filter_fecha_fin" name="fecha_fin" type="text" class="form-control date-picker" placeholder="dd/mm/aaaa" maxlength="10" required="required" readonly="" value="<?php echo $fecha_fin;?>">
                        <div class="invalid-feedback">No es una fecha válida.</div>
                    </div>
                </div>
                <div class="col-12 text-center">
                    <button type="submit" class="btn btn-outline-primary">
                        <span class="ing-buscar ing-fw"></span>
                        Filtrar
                    </button>
                    <button type="button" class="btn btn-outline-danger btn-reset">
                        <span class="ing-borrar ing-fw"></span>
                        Limpiar
                    </button>
                </div>
            </div>
        </form>
        <!-- Tabla -->
        <?php
        if(count($dias_arr) > 0){ ?>
            <div class="row mt-3">
                <div class="col-12 table-responsive">
                    <table class="table table-sm table-striped table-white">
                        <thead class="thead-dark">
                            <tr>
                                <th>Día</th>
                                <th>Periodo</th>
                                <?php if($user->admin){ ?>
                                <th>Acciones</th>
                                <?php } ?>
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach($dias_arr as $dia){ ?>
                            <tr data-id="<?= $dia['diasfestivos_id'] ?>" id="<?= $dia['diasfestivos_id'] ?>" data-periodo="1">
                                <td class="text-center text-nowrap align-middle">
                                    <?php $day =  explode("-", $dia['diasfestivos_dia']);
                                        echo $dias_nombres[$dia["dia_id"]]."<br>";
                                        echo $day[2]."/".$day[1]."/".$day[0];
                                    ?></td>
                                <td>
                                    <ul class="mb-0">
                                    <?
                                    foreach($dia["periodos"] as $per){
                                        echo "<li>".$per['periodo_nombre']."</li>";
                                    }
                                    ?>
                                    </ul>
                                </td>
                                <?php if($user->admin){ ?>
                                <td class="text-center icono-acciones align-middle">
                                    <a href="#" data-toggle="modal" data-target="#modal" data-tipo="2" title="Editar"><span class="ing-editar ing-fw"></span></a>
                                    <a href="#" data-toggle="modal" data-target="#modal_confirm" title="Borrar"><span class="ing-basura ing-fw"></span></a>
                                </td>
                                <?php } ?>
                            </tr>
                            <?php } ?>
                            
                        </tbody>
                    </table>
                </div>
            </div>
        <?php } ?>
    </main>
    <!-- Footer -->
    <?php
    include "import/html_footer.php";
    ?>
    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modal" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="col-12 modal-title text-center">
                        <span id="modalLabel">
                            Editar Día Festivo
                        </span>
                        <button type="button" class="close text-white" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </h4>
                </div>
                <div class="modal-body">
                    <form action="" method="post" id="formaModal" onsubmit="return valida_campos()">
                        <input type="hidden" name="id" id="id">
                        <div class="form-box">
                            <div class="form-group row" id="rangoDiv">
                                <label for="rango" class="col-3 col-form-label">Rango</label>
                                <div class="col-8">
                                    <input type="checkbox" data-toggle="toggle" data-onstyle="success" data-offstyle="danger" data-on="SI" data-off="NO" data-size="s" id="rango" name="rango">
                                </div>
                            </div>
                            <div class="form-group row" id="diasFestivos">
                                <label for="diaFestivo" class="col-3 col-form-label">Día festivo *</label>
                                <div class="col-4" id="dia">
                                    <input id="diaFestivo" name="diaFestivo" type="text" class="form-control date-picker" placeholder="dd/mm/aaaa" maxlength="10" required="required" readonly="">
                                </div>
                                <div class="col-1 diaFestivoRango">
                                    <span class="ing-menos pt-2"></span>
                                </div>
                                <div class="col-4 diaFestivoRango" id="diaFestivoRango">
                                    <input id="diaFestivoFin" name="diaFestivoFin" type="text" class="form-control date-picker" placeholder="dd/mm/aaaa" maxlength="10" required="required" readonly="">
                                </div>
                                <div class="invalid-feedback">Debe seleccionar una fecha</div>
                            </div>

                            <div class="form-group row" id="periodos">
                                <label for="periodos" class="col-3 col-form-label">Periodos</label>
                                <div class="col-9" style="overflow-y:auto; overflow-x:none; max-height:220px; font-size:80%">
                                    <?php
                                    foreach($fs_periodos as $per){
                                    ?>
                                        <div class="form-check form-check-inline" data-fechaini = "<?php echo $per["periodo_fecha_inicio"];?>" data-fechafin = "<?php echo $per["periodo_fecha_fin"];?>">
                                            <input class="form-check-input radio-lg " type="checkbox" id="check<?php echo $per["periodo_id"]?>" name="periodo[]" value="<?php echo $per["periodo_id"]?>">
                                            <label for="check<?php echo $per["periodo_id"]?>" class="col-form-label"><?php echo $per["periodo_nombre"]?></label> 
                                        </div>
                                    <?php 
                                    }
                                    ?>
                                </div>
                                
                            </div>

                            <div class="form-group row">
                                <div class="offset-4 col-8">
                                    <button type="submit" class="btn btn-outline-primary" id="submitBtn" data-tipo="1">
                                        <span class="ing-aceptar ing-fw"></span> Guardar
                                    </button>
                                    <button type="reset" class="btn btn-outline-danger" data-dismiss="modal">
                                        <span class="ing-cancelar ing-fw"></span> Cancelar
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal_confirm" tabindex="-1" role="dialog" aria-labelledby="modal_confirm" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="row">
                        <div class="col">
                            <p class="font-weight-bold">¿Estás seguro de querer borrar el día festivo?</p>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <input type="hidden" id="id_borrar" value="">
                    <button type="button" class="btn btn-outline-primary btn-borrar"><span class="ing-aceptar ing-fw"></span> Borrar</button>
                    <button type="button" class="btn btn-outline-danger" data-dismiss="modal" aria-label="Close"><span class="ing-cancelar ing-fw"></span> Cancelar</button>
                </div>
            </div>
        </div>
    </div>

    <script src="js/jquery.min.js"></script>
    <script src="js/jquery-ui.js"></script>
    <script src="js/bootstrap/bootstrap.min.js"></script>
    
    <script src="js/datepicker-es.js"></script>
    <script src="js/toggle.js"></script>
    <?php
        require_once 'js/messages.php';
    ?>
    <script>
        $(document).on( "click", ".btn-reset", function(event){
            var forma = $(this).parents("form");
            forma.find("input[type=text]").val("");
            forma.submit();
        });


        $(document).ready(function(){
            $('.diaFestivoRango').hide();
        });
        $('#rango').change(function(){
            if($(this).is(':checked')){
                $('#diaFestivoFin').val('');
                $('.diaFestivoRango').show();
                $('#diaFestivoFin').datepicker("setDate", today);
            }
            else{
                $('.diaFestivoRango').hide();
            }
        });

        $('#modal_confirm').on('show.bs.modal', function(event){
            var button = $(event.relatedTarget);
            var id = button.parents("tr").data("id");
            $("#id_borrar").val(id);
        });

        $(".btn-borrar").click(function(){
            var id = $("#id_borrar").val();
            $.ajax({
                url: 'action/action_diasfestivos_borra.php',
                type: 'post',
                dataType: 'json',
                data:{id: id},
                success:function(result){
                    location.reload();
                },
                error: function(){console.log("Error")}
            });
        });

        var today = new Date();
        $(".date-picker").datepicker($.datepicker.regional["es"]);
        $(".date-picker").datepicker({
            dateFormat: "dd/mm/yyyy",
            changeMonth: true,
        });

    <?php if(count($dias_arr) == 0){ ?>
        triggerMessage("No se encontraron días festivos", "Error");
    <?php } ?>

        function actualizaPeriodos(fechaOriginal){
            var partesFecha = fechaOriginal.split('/');
            var fechaFestivo = partesFecha[2]+"-"+partesFecha[1]+"-"+partesFecha[0];

            $.each($('#periodos .form-check'), function(){
                if(fechaFestivo>= $(this).data("fechaini") && fechaFestivo<= $(this).data("fechafin")){
                    $(this).show();
                }else{
                    $(this).find("input").prop("checked", false);
                    $(this).hide();
                }
            });
        }

        //Cambio de fecha valida periodos activos para esa fecha
        $('#modal .date-picker').change(function(){
            actualizaPeriodos($(this).val());
        });
        $('#modal').on('show.bs.modal', function (event){
            var button = $(event.relatedTarget);
            var tipo = button.data('tipo');
            var modal = $(this);
            $("#formaModal .text-danger").removeClass("text-danger");
            $("#diaFestivoFin").removeClass("is-invalid");
            if(tipo==1){//agregar
                $('#modalLabel').html("Agregar Día Festivo");
                $('#submitBtn').data('tipo', 1);
                $('#diaFestivo').datepicker("setDate", today);
                $('#diaFestivoFin').datepicker("setDate", today);
                $('#rangoDiv').show();
                $('#dia').removeClass('col-9');
                $('#dia').addClass('col-4');
                actualizaPeriodos($("#diaFestivo").val());
            }
            else{
                $('#modalLabel').html("Editar Día Festivo");
                $('#submitBtn').data('tipo', 2);
                $('#rangoDiv').hide();
                $('#dia').removeClass('col-4');
                $('#dia').addClass('col-9');
                var id = $(event.relatedTarget).parents('tr').data('id');
                var periodo = $(event.relatedTarget).parents('tr').data('periodo');
                $.ajax({
                    url:"action/action_diasfestivos_select.php",
                    type:"post",
                    dataType:"json",
                    data:{id: id, periodo: periodo},
                    success:function(result){
                        console.log(result);
                        $('#id').val(result['diasfestivos_id']);
                        
                        var date = new Date(result['diasfestivos_dia']);
                        date.setDate(date.getDate() + 1);
                        $('#diaFestivo').datepicker("setDate", date);
                    },
                    error: function(){console.log("Error")}
                });
            }
        });

        function valida_campos(){
            var error=false;
            $("#modal .text-danger").removeClass("text-danger");
            $("#diaFestivoFin").removeClass("is-invalid");
            if($("#diaFestivo").val()==""){
                $("#diaFestivo").addClass("is-invalid");
                error=true;
            }
            var inicio = $("#diaFestivo").val();
            var fin = $("#diaFestivoFin").val();
            var aux = inicio.split("/");
            inicio = aux[2] +"-"+ aux[1] +"-"+ aux[0];
            aux = fin.split("/");
            fin = aux[2] +"-"+ aux[1] +"-"+ aux[0];
            console.log(inicio);
            if((fin < inicio || fin == inicio)  && $("#rango").is(':checked')){
                $('#diaFestivoFin').addClass("is-invalid");
                error=true;
            }
            if($("#modal .form-check-input:checked").length<=0){
                $("#modal .form-check-input").siblings().addClass("text-danger");
                error=true;
            }
            if(error){
                return false;
            }else{
                var btn = $("#submitBtn");
                if(btn.data("tipo") == 2){//update
                    $("#formaModal").prop("action", "./action/action_diasfestivos_update.php");
                }
                else{//insert
                    $("#formaModal").prop("action", "./action/action_diasfestivos_insert.php");
                }
            }
        }
        
        <?php if(isset($_GET['error'])){ 
            if($_GET['error'] == 1){ ?>
                triggerMessage("Este dia festivo ya existe", "Error");
        <?php }
        } ?>
    </script>
</body>
</html>